/*
 *  Simple test program -- simplified version of sample test hello.
 */

#include <bsp.h>

#include <stdlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include <rtems/ramdisk.h>
#include <rtems/bdbuf.h>

rtems_task Init(
  rtems_task_argument ignored
)
{
  FILE *fp;
  unsigned char *b1, *b2;
  int i;
  size_t s;

  fp = fopen( "/dev/ramdisk0", "r+" );
  assert( fp );

  b1 = calloc( 1, 256 );
  assert( b1 );

  b2 = calloc( 1, 256 );
  assert( b2 );

  for ( i=0 ; i<= 255 ; i++  )
    b1[i] = (unsigned char) i;

  for (i=0; i<40 ; i++ ) {
    s = fwrite( b1, 256, 1, fp );
    assert( s == 1 );
  }

  s = fwrite( b1, 256, 1, fp );
  printf( "%d %d\n", s, ferror( fp ) );
  assert( !s );

  i = fseek( fp, SEEK_SET, 0 );
  assert( !i ) ;
  for (i=0; i<40 ; i++ ) {
    memset( b2, 0, 256 );
    s = fread( b2, 256, 1, fp );
    assert( s == 1 );

    assert( !memcmp( b1, b2, 256 ) );
  }



  exit( 0 );
}

/* configuration information */

#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER

#define CONFIGURE_RTEMS_INIT_TASKS_TABLE

#define CONFIGURE_MAXIMUM_TASKS 10
#define CONFIGURE_MAXIMUM_SEMAPHORES 10
#define CONFIGURE_LIBIO_MAXIMUM_FILE_DESCRIPTORS 4

rtems_bdbuf_config rtems_bdbuf_configuration[] = {
  { 512, 20, (void *) 0 }
};
int rtems_bdbuf_configuration_size = 1;

rtems_ramdisk_config rtems_ramdisk_configuration[] = {
  {
     512, 20, (void *) 0
  }
};

int rtems_ramdisk_configuration_size = 1;

#define CONFIGURE_HAS_OWN_DEVICE_DRIVER_TABLE
rtems_driver_address_table Device_drivers[] = {
  CONSOLE_DRIVER_TABLE_ENTRY,
  CLOCK_DRIVER_TABLE_ENTRY,
  RAMDISK_DRIVER_TABLE_ENTRY
};
#define CONFIGURE_NUMBER_OF_DRIVERS \
  ((sizeof(Device_drivers) / sizeof(rtems_driver_address_table)))
#define CONFIGURE_MAXIMUM_DRIVERS 10

#define CONFIGURE_INIT

#include <confdefs.h>

/* end of file */
